
unit FxEngine;


{
  In this unit you will find function prototypes
  and structures that you need to use FxEngine 0.41
  in your applications. You will also need
  to put the fxenginedll.dll file in the same directory
  as your application.
}

{

04/01/1999 -  Added functions fxeCameraEnableSyncToPoint and
              fxeCameraDisableSyncToPoint.
              Fixed the fxeLandscapeLoadFromFile call.
}

interface

uses Windows;

// First some constants:

const FXE_SHAPE_POLYGONS = 0;
      FXE_SHAPE_LINES = 1;
      FXE_SHAPE_POINTS = 2;

      FXE_TEXTURE_MAP = 0;
      FXE_TEXTURE_SPECIAL = 1;

      FXE_RES_640x480 = 0;
      FXE_RES_800x600 = 1;
      FXE_RES_1024x768 = 2;
      FXE_RES_1280x1024 = 3;
      FXE_RES_1600x1200 = 4;

      W_BUFFERING_ENABLED = 0;
      W_BUFFERING_DISABLED = 1;

      FXE_RENDER_2D = 0;
      FXE_RENDER_3D = 1;

      OBJECT_3DS = 0;

      LOAD_FROM_FILE = 0;
      LOAD_FROM_MEMORY = 1;

      fxeBackBuffer = 0;
      fxeFrontBuffer = 1;

      NO_FOGGING = 0;
      DISTANCE_FOGGING = 1;

      LOW_DETAIL = 0;
      HIGH_DETAIL = 1;
      MAXIMUM_DETAIL = 2;
      AUTOMATIC_DETAIL = 3;

      GOURAUD_SHADING = 1;
      PHONG_SHADING = 2;
      FLAT_SHADING = 3;
      GOURAUD_SHADING_WSH = 4;

      OBJECT_COMPLETELY_TEXTURED = 0;
      OBJECT_NOT_TEXTURED = 1;
      OBJECT_COMBO = 2;

      ONLY_TEXTURED = 0;
      TEXTURE_MAPPED = 1;
      NOT_TEXTURED = 2;
      BUMP_MAPPED = 4;
      ENVIROMENT_MAPPED = 8;

      TRILINEAR_FILTERED = 0;
      BILINEAR_FILTERED = 1;

      FXETRUE = 1;
      FXEFALSE = 0;

// Some global variables:

var

  HorRes : Single;
  VerRes : Single;

  HalfHorRes : Single;
  HalfVerRes : Single;

type

  fxeTextureHandle = Pointer;
  ppfxeTexture = ^fxeTextureHandle;
  fxeLensflareHandle = Pointer;
  fxeSmokeEmitterHandle = Pointer;

  fxeColor = record
    r : single;
    g : single;
    b : single;
  end;

  pfxeColor = ^fxeColor;

  fxeCharacterHandle = Pointer;
  fxeCharactersetHandle = Pointer;

  fxePerformance = record
    NumPolys : Integer;
    FrameCount : Integer;
  end;

  pfxePerformance = ^fxePerformance;

  fxeObjectHandle = Pointer;

  fxeCameraHandle = Pointer;

  fxeLightsourceHandle = Pointer;

  fxeLandscapesParentHandle = Pointer;

  fxeDynLightsourceHandle = Pointer;

  fxeEmitterHandle = Pointer;

  pSingle = ^Single;
  pInteger = ^Integer;
  pByte = ^Byte;

  fxeVector = record
    x : single;
    y : single;
    z : single;
  end;

  pfxeVector = ^fxeVector;


// functions:


function fxeInitialize(WindowHandle : HWND; ResToUse : Integer) : Integer; cdecl; external 'fxenginedll.dll';
procedure fxeShutdown; cdecl; external 'fxenginedll.dll';
procedure fxeResolutionGet(HorisontalRes : pSingle; VerticalRes : pSingle); cdecl; external 'fxenginedll.dll';
procedure fxeRenderWindowSet(x : Integer; y : Integer; Width : Integer; Height : Integer); cdecl; external 'fxenginedll.dll';
function VectorLenght(var Vector : fxeVector) : single; cdecl; external 'fxenginedll.dll';
procedure CrossProduct3d(var Result : fxeVector; var Vector1 : fxeVector; var Vector2 : fxeVector); cdecl; external 'fxenginedll.dll';
function DegToRad(Degree : single) : single; cdecl; external 'fxenginedll.dll';
procedure fxeGetVersion(var MainVersion : Integer; var UnderVersion : Integer); cdecl; external 'fxenginedll.dll';
procedure fxeCameraMove(x : single; y : single; z : single); cdecl; external 'fxenginedll.dll';
procedure fxeCameraRotate(xa : single; y : single; z : single); cdecl; external 'fxenginedll.dll';
procedure fxeAmbientlightLight(r : single; g : single; b : single); cdecl; external 'fxenginedll.dll';
function fxeLensflareCreate(NumFlares : Integer; TextureHandles : ppfxeTexture;
  Radiuses : pSingle; MulFactors : pSingle) : fxeLightsourceHandle; cdecl; external 'fxenginedll.dll';
function fxeLightsourceAdd(r : single; g : single; b : single; x : single; y : single; z : single;
  DistanceAffection : single; LFH : fxeLensflareHandle; LightVector : pfxeVector) : fxeLightsourceHandle; cdecl; external 'fxenginedll.dll';
procedure fxeLightsourceMove(LightsourceHandle : fxeLightsourceHandle; x : single; y : single;
  z : single); cdecl; external 'fxenginedll.dll';
procedure fxelightsourceLight(LightsourceHandle : fxeLightsourceHandle;
  r : single; g : single; b : single); cdecl; external 'fxenginedll.dll';
procedure fxeLightsourceDelete(LightsourceHandle : fxeLightsourceHandle); cdecl; external 'fxenginedll.dll';
function fxeTextureLoad(filename : PCHAR; TexType : byte) : fxeTextureHandle; cdecl; external 'fxenginedll.dll';
procedure fxeObjectAddVertex(ObjectHandle : fxeObjectHandle;
  x : single; y : single; z : single); cdecl; external 'fxenginedll.dll';
procedure fxeObjectAddPolygon(ObjectHandle : fxeObjectHandle; VertexIndex1 : Integer;
  VertexIndex2 : Integer; VertexIndex3 : Integer; DoubleSidedState : Integer; TH : fxeTextureHandle;
  u0 : single; v0 : single; u1 : single; v1 : single; u2 : single; v2 : single); cdecl; external 'fxenginedll.dll';
procedure fxeObjectPerformPrecalculations(ObjectHandle : fxeObjectHandle; ObjectSize : single);
  cdecl; external 'fxenginedll.dll';
function fxeObjectInitDefaultState : fxeObjectHandle; cdecl; external 'fxenginedll.dll';
function fxeObjectLoad(filename : PCHAR; FileFormat : Integer; ScaleFactor : single; UseTexture : Integer) :
  fxeObjectHandle; cdecl; external 'fxenginedll.dll';
function fxeObjectLoadFromExe(ResID : Integer; FileFormat : Integer; ScaleFactor : Single; UseTextures : Integer) :
  fxeObjectHandle; cdecl; external 'fxenginedll.dll';
procedure fxeObjectSetShape(ObjectHandle : fxeObjectHandle; Shape : Integer);
  cdecl; external 'fxenginedll.dll';
procedure fxeObjectSetEnviromentAlpha(ObjectHandle : fxeObjectHandle; EnviromentAlphaLevel : single);
  cdecl; external 'fxenginedll.dll';
function fxeObjectAdd(ObjectHandle : fxeObjectHandle) : fxeObjectHandle;
  cdecl; external 'fxenginedll.dll';
procedure fxeObjectRotate(ObjectHandle : fxeObjectHandle; xa : single; ya : single; za : single);
  cdecl; external 'fxenginedll.dll';
procedure fxeObjectSetShadingType(ObjectHandle : fxeObjectHandle; ShadingType : Integer);
  cdecl; external 'fxenginedll.dll';
procedure fxeObjectMakeEnviromentMapped(OH : fxeObjectHandle; TH : fxeTextureHandle; AlphaLevel : single);
  cdecl; external 'fxenginedll.dll';
procedure fxeObjectMove(ObjectHandle : fxeObjectHandle; x : single; y : single; z : single);
  cdecl; external 'fxenginedll.dll';
procedure fxeObjectScale(ObjectHandle : fxeObjectHandle; Scale : single);
  cdecl; external 'fxenginedll.dll';
procedure fxeObjectDelete(ObjectHandle : fxeObjectHandle); cdecl; external 'fxenginedll.dll';
procedure fxeWorldRender(DisplayWorld : Integer); cdecl; external 'fxenginedll.dll';
procedure fxeWorldDisplay; cdecl; external 'fxenginedll.dll';
function fxeCharactersetLoad(FilePrefix : PCHAR; UseDefaultSettings : Integer; Translucent : Integer;
  AlphaLevel : single; Transparent : Integer; TransColor : pfxeColor; Spacing : single;
  CharWidth : single; CharHeight : single) : fxeCharactersetHandle; cdecl; external 'fxenginedll.dll';
procedure fxeSetDefaultCharacterset(CSH : fxeCharactersetHandle); cdecl; external 'fxenginedll.dll';
procedure fxeCharactersetSetDefaultDrawingMode(CSH : fxeCharactersetHandle);
  cdecl; external 'fxenginedll.dll';
procedure fxeCharactersetSetSpecialDrawingMode(CSH : fxeCharactersetHandle; Translucent : integer;
  AlphaLevel : single; Transparent : Integer; TransColor : pfxeColor; Spacing : single;
  CharacterWidth : single;  CharacterHeight : single); cdecl; external 'fxenginedll.dll';
procedure fxeStringDrawXY(DrawString : PCHAR; x : single; y : single); cdecl; external 'fxenginedll.dll';
function fxeBitmapCreate(TextureHandle : fxeTextureHandle; Translucent : Integer;
  AlphaLevel : single; Transparent : Integer; TransparentColor : pfxeColor) : fxeCharacterHandle;
  cdecl; external 'fxenginedll.dll';
procedure fxeBitmapDrawXY(CharHandle : fxeCharacterHandle; x : single; y : single;
  Width : single; Height : single); cdecl; external 'fxenginedll.dll';
procedure fxeCharacterDraw(CharHandle : fxeCharacterHandle; x : single; y : single;
  Width : single; Height : single); cdecl; external 'fxenginedll.dll';
procedure fxeFogSetMode(FogMode : Integer); cdecl; external 'fxenginedll.dll';
procedure fxeFogSetColor(FogColor : pfxeColor); cdecl; external 'fxenginedll.dll';
procedure fxeStartFrameCount; cdecl; external 'fxenginedll.dll';
function fxeGetFrameCount : Integer; external 'fxenginedll.dll';
procedure fxeBackgroundSetColor(pColor : pfxeColor); cdecl; external 'fxenginedll.dll';
procedure fxeBackgroundClear; cdecl; external 'fxenginedll.dll';
procedure fxeSetRenderState(RenderState : Integer); cdecl; external 'fxenginedll.dll';
procedure fxePerformanceInit; cdecl; external 'fxenginedll.dll';
function fxePerformanceGet : pfxePerformance; cdecl; external 'fxenginedll.dll';
procedure fxeVSyncEnable; cdecl; external 'fxenginedll.dll';
procedure fxeVSyncDisable; cdecl; external 'fxenginedll.dll';
procedure fxeObjectMakeTranslucent(ObjectHandle : fxeObjectHandle; AlphaLevel : single);
  cdecl; external 'fxenginedll.dll';
procedure fxeObjectDisableTranslucency(ObjectHandle : fxeObjectHandle); cdecl; external 'fxenginedll.dll';
procedure fxeLooseFocus; cdecl; external 'fxenginedll.dll';
procedure fxeSetFocus; cdecl; external 'fxenginedll.dll';
procedure fxeFarClippingPlaneSet(Distance : single); cdecl; external 'fxenginedll.dll';
procedure fxeCameraSetActive(CH : fxeCameraHandle); cdecl; external 'fxenginedll.dll';
function fxeCameraCreate(wx : single; wy : single; wz : single;
  ax : single; ay : single; az : single) : fxeCameraHandle; cdecl; external 'fxenginedll.dll';
procedure fxeCameraMoveIncremental(NumFrames : Integer; pMoveVector : pfxeVector; RotX : single;
  RotY : single; RotZ : single); cdecl; external 'fxenginedll.dll';
procedure fxeCameraEnableSyncToPoint(x : single; y : single; z : single); cdecl; external 'fxenginedll.dll';
procedure fxeCameraDisableSyncToPoint; cdecl; external 'fxenginedll.dll';
function fxeObjectDetectCollision(OH1 : fxeObjectHandle; OH2 : fxeObjectHandle) : Integer;
  cdecl; external 'fxenginedll.dll';
function fxeLandscapeGetHeightXZ(LspH : fxeLandscapesParentHandle; x : single; z : single) : single;
  cdecl; external 'fxenginedll.dll';
function fxeObjectDetectCollisionLandscape(OH : fxeObjectHandle; LspH : fxeLandscapesParentHandle) : Integer;
  cdecl; external 'fxenginedll.dll';
function fxeLandscapeLoadFromFile(GeometryFile : PCHAR; ColorFile : PCHAR; TH : fxeTextureHandle;
  Widht : single; Depth : single; Height : single; LightVector : pfxeVector; Intensity : single) : fxeLandscapesParentHandle;
  cdecl; external 'fxenginedll.dll';
procedure fxeLandscapeAddToWorld(pLandscape : fxeLandscapesParentHandle); cdecl; external 'fxenginedll.dll';
procedure fxeLandscapeRemoveFromWorld; cdecl; external 'fxenginedll.dll';
function fxeEmitterCreate(x : single; y : single; z : single; NumParticles : Integer; InitColor : pfxeColor;
  FinishColor : pfxeColor; TexHandle : fxeTextureHandle; ForceVector : pfxeVector; ForceAcceleration : single;
  ParticleRadius : single; Magnitude : single) : fxeEmitterHandle; cdecl; external 'fxenginedll.dll';
procedure fxeEmitterAddParticles(pEmitter : fxeEmitterHandle; NumParticles : Integer); cdecl; external 'fxenginedll.dll';
procedure fxeEmitterAddParticle(pEmitter : fxeEmitterHandle); cdecl; external 'fxenginedll.dll';
procedure fxeEmitterAddToWorld(pEmitter : fxeEmitterHandle); cdecl; external 'fxenginedll.dll';
procedure fxeEmitterRemoveFromWorld(pEmitter : fxeEmitterHandle); cdecl; external 'fxenginedll.dll';
procedure fxeEmitterChangeProperties(pEmitter : fxeEmitterHandle; x : single; y : single; z : single; ForceVector : pfxeVector);
  cdecl; external 'fxenginedll.dll';
function fxeDynLightsourceAdd(Radius : single; x : single; y : single; z : single;
  r : single; g : single; b : single) : fxeDynLightsourceHandle; cdecl; external 'fxenginedll.dll';
procedure fxeDynLightsourceDisable(DLSH : fxeDynLightsourceHandle); cdecl; external 'fxenginedll.dll';
procedure fxeDynLightsourceActivate(DLSH : fxeDynLightsourceHandle); cdecl; external 'fxenginedll.dll';
procedure fxeDynLightsourceChangeXYZ(DLSH : fxeDynLightsourceHandle;
  NewX : single; NewY : single; NewZ : single); cdecl; external 'fxenginedll.dll';
procedure fxeDynLightsourceChangeRGB(DLSH : fxeDynLightsourceHandle;
  NewR : single; NewG : single; NewB : single); cdecl; external 'fxenginedll.dll';
procedure fxeDynLightsourceChangeRadius(DLSH : fxeDynLightsourceHandle; NewRadius : single);
  cdecl; external 'fxenginedll.dll';
procedure fxeStrDrawGrid(x : integer; y : integer; str : PCHAR); cdecl; external 'fxenginedll.dll';
function fxeNumBytesAllocated : DWORD; cdecl; external 'fxenginedll.dll';
function fxeSkyboxAdd(Radius : single; FrontTexture : fxeTextureHandle; LeftTexture : fxeTextureHandle;
  RearTexture : fxeTextureHandle; RightTexture : fxeTextureHandle;
  UpTexture : fxeTextureHandle; DownTexture : fxeTextureHandle) : Integer; cdecl; external 'fxenginedll.dll';
procedure fxeSkyboxDisable; cdecl; external 'fxenginedll.dll';
function fxeSmokeEmitterCreate(x : single; y : single; z : single; NumParticles : Integer;
  TexHandle : fxeTextureHandle; Radius : single; ForceVector : pfxeVector; ForceAcceleration : single;
  ParticleRadius : single; Magnitude : single; Life : Integer; Opacity : Integer) : fxeSmokeEmitterHandle;
  cdecl; external 'fxenginedll.dll';
procedure fxeSmokeEmitterAddToWorld(pEmitter : fxeSmokeEmitterHandle); cdecl; external 'fxenginedll.dll';
procedure fxeSmokeEmitterRemoveFromWorld(pEmitter : fxeSmokeEmitterHandle); cdecl; external 'fxenginedll.dll';
procedure fxeSmokeEmitterChangeProperties(pEmitter : fxeSmokeEmitterHandle;
  x : single; y : single; z : single; ForceVector : pfxeVector); cdecl; external 'fxenginedll.dll';
procedure fxeSmokeEmitterChangeOpacity(pSmokeEmitter : fxeSmokeEmitterHandle;
  Opacity : Integer); cdecl; external 'fxenginedll.dll';




implementation



end.
