program FxeTest;

// simple test application for fxengine. Just
// loads a 3ds object a landscape and displays
// them on the screen.

uses
  Forms,
  SysUtils,
  classes,
  FxEngine in 'FxEngine.pas',
  FxTest in 'FxTest.pas' {fmFxTest},
  fxthread in 'fxthread.pas';

{$R *.RES}

var
  TH : fxeTextureHandle;
  Landscape : fxeLandscapesParentHandle;
  LightVec : pfxeVector;
  Vec : fxeVector;
begin

  Application.Initialize;

  Application.CreateForm(TfmFxTest, fmFxTest);
  fmFxTest.Show();

  // Initialize FxEngine, set the resolution to
  // 640x480.

  fxeInitialize(fmFxTest.Handle,FXE_RES_640x480);

  // Load a object, put the handle to the object in OH
  OH := fxeObjectAdd(fxeObjectLoad(PTC('tank.3ds'),OBJECT_3DS,100,FXETRUE));

  // Load a landscape from a 3df file, a texture to use
  // as material on the landscape and add the landscape
  // to the world so we can see it.

  TH := fxeTextureLoad(PTC('ground2.3df'),FXE_TEXTURE_MAP);
  if (TH = nil) then
  begin
    fxeShutdown();
    Exit;
  end;

  Vec.x := 0;
  Vec.y := 0;
  Vec.z := 1;

  // Add a lightsource
  fxeLightsourceAdd(1,1,1,10000,10000,10000,0,nil,VecPtr(0,0,0));

  Landscape :=
    fxeLandscapeLoadFromFile(PTC('hills.3df'),nil,
    TH,10000,10000,1000,@Vec,1);
  if (Landscape = nil) then
  begin
    fxeShutdown;
    Exit;
  end;


  fxeLandscapeAddToWorld(Landscape);



  // Set the camera position to 0,400,-300);
  fxeCameraMove(0,700,-300);

  // Move the object so it will be visible in front of the camera
  fxeObjectMove(OH,0,700,0);

  // The application is terminated when the
  // user presses a key, using the OnKeyDown
  // event handler of the main window.

  // Create a thread that will rotate the object and render
  // the world:



  FxMainThread := TFxMainThread.Create(FALSE);

  Application.Run;
end.
