unit fxthread;

interface

uses Classes, FxEngine, SysUtils, Dialogs;

function VecPtr(x : single; y : single; z : single) : pfxeVector;
function PTC(InStr : string) : PCHAR;

// This thread rotates the object and renders the world
type
  TFxMainThread = class(TThread)
    protected
      procedure Execute; override;
  end;


var
  FxMainThread : TFxMainThread;
  OH : fxeObjectHandle;
  CamZ : single;

implementation

procedure TFxMainThread.Execute;
begin
  CamZ := -300;

  while (Terminated = FALSE) do
  begin


    fxeBackgroundClear();
    fxeObjectRotate(OH,1,1,1);
    fxeCameraMove(0,700,CamZ);
    fxeWorldRender(FXEFALSE);
    //fxeSetRenderState(FXE_RENDER_2D);
    //fxeStrDrawGrid(0,0,PTC('FxEngine 0.40 by Andreas Ingo 1998.'));
    //fxeStrDrawGrid(0,1,PTC('Bytes Allocated: '+IntToStr(fxeNumBytesAllocated())));
    //fxeSetRenderState(FXE_RENDER_3D);

    fxeWorldDisplay();

  end;
  fxeShutdown();
end;

// Takes x,y,z components and returns a pointer
// to a vector. Takes a vectors x,y,z components
// and returns a pointer to a fxengine compatible vector.
function VecPtr(x : single; y : single; z : single) : pfxeVector;
var
  DynVector : pfxeVector;
begin
  New(DynVector);
  DynVector^.x := x;
  DynVector^.y := y;
  DynVector^.z := z;
  Result := DynVector;
end;

// Takes a pascal style string and returns a pointer to
// a c style string which you can use in FxEngine calls.
// The string specified can't hold more than 80 characters.
function PTC(InStr : string) : PCHAR;
var
  DynString : PCHAR;
begin
  DynString := StrAlloc(80);
  StrPCopy(DynString,InStr);
  Result := DynString;
end;

end.
