

// This is the source for the particle system
// for FxEengine. Many thanks goes to Daniel
// M Jones. I didn't actually copy his code 
// but I got a lot of ideas on how to do it from
// his code. 

#define _FXSMOKE_

#ifndef _FXENGINE_
#include "fxenginedrv.h"
#endif



typedef struct
{
  // world position:
  float x,y,z;

  // The direction the Particle is moving to 
  fxeVector DirectionVector;

  // Radius of particle:
  float Radius;

	float Alpha;
	float AlphaInc;

  // The number of frames left this particle will last:
  int NumFramesLeft;

	fxeVector ForceVector;

  void *Prev;
  void *Next;

} fxeSmokeParticle;

typedef struct
{
	float x, y, z;
	int ParticleCount;
	float cz;
	float Radius;
	int Life;
	int Opacity;
  fxeTextureHandle TexHandle;
  int TotalParticles;
  int NumParticles;
  // This variable is always pointing to the first particle in the
  // linked list of particles in this emitter.
  fxeSmokeParticle *UsedParticles;
  // This is a pointer to the first unused space for a particle in the
  // linked list
  fxeSmokeParticle *UnusedParticles;
  fxeVector ForceVector;
  // The ForceVector is multiplied by this constant each frame:
  // If ForceAcceleration is 2 the force is doubling it's strenght each frame
  float ForceAcceleration;
	float ParticleRadius;
	float Magnitude;
	void *Prev;
	void *Next;
} fxeSmokeEmitter, *fxeSmokeEmitterHandle;



fxeSmokeEmitterHandle fxeSmokeEmitterCreate(float x, float y, float z, 
	int NumParticles, fxeTextureHandle TexHandle, float Radius,
  fxeVector *ForceVector, float ForceAcceleration, float
	ParticleRadius, float Magnitude, int Life, int Opacity);


void fxeSmokeEmitterAddParticles(fxeSmokeEmitterHandle pEmitter);

void fxeSmokeEmitterAddParticle(fxeSmokeEmitterHandle pEmitter);

void fxeSmokeEmitterTranslateFrame(fxeSmokeEmitterHandle pEmitter);

void fxeSmokeEmitterClipAndDraw(fxeSmokeEmitterHandle pEmitter);

void fxeSmokeEmitterUpdateFrame(fxeSmokeEmitterHandle pEmitter);

void fxeSmokeEmitterAddToWorld(fxeSmokeEmitterHandle pEmitter);

void fxeSmokeEmitterRemoveFromWorld(fxeSmokeEmitterHandle pEmitter);

void fxeSmokeSystemInit(void);

void fxeSmokeEmitterChangeProperties(fxeSmokeEmitter *pEmitter, 
	float x, float y, float z, fxeVector *ForceVector);

void fxeSmokeEmitterChangeOpacity(fxeSmokeEmitter *pSmokeEmitter,
	int Opacity);

fxeSmokeEmitter *pSmokeEmitters;


