
#include <windows.h>

#define FXE_MAX_DYN_LIGHTSOURCES 100
#define _FXDYNLIGHTSOURCE_

typedef struct 
{
	// The radius around the lightsource. The distance
	// from the lightsource where it is no light
	float Radius;
	// 1.0f/Radius
	float Oor;
	float x,y,z;
	// r,g,b in the range 0..31
	float r,g,b;
	float RDiv31, GDiv31, BDiv31;
	unsigned char Active;
	// Indicates in the properties of this lightsource have changed in this frame.
	// FXETRUE if properties have changed and FXEFALSE if not.
	unsigned char Changed;
	// Pointer to next lightsource in list
	void *Next;
	// Pointer to next lightsource in list
	void *Prev;
	unsigned char HaveMoved;
} fxeDynLightsource, *fxeDynLightsourceHandle;

extern fxeDynLightsource *DynamicLightsources;
extern fxeDynLightsource *FirstDynLightsource;

void fxeDynLightsourcesMakeUnchanged(void);
void fxeDynLightsourcesMakeUnMoved(void);
fxeDynLightsourceHandle fxeDynLightsourceAdd(float Radius, float x, float y, float z, 
	float r, float g, float b);
void fxeDynLightsourceDisable(fxeDynLightsourceHandle DLSH);
void fxeDynLightsourceActivate(fxeDynLightsourceHandle DLSH);
void fxeDynLightsourceChangeXYZ(fxeDynLightsourceHandle DLSH, float NewX, float NewY, float NewZ);
void fxeDynLightsourceChangeRGB(fxeDynLightsourceHandle DLSH, float NewR, float NewG, float NewB);
void fxeDynLightsourceChangeRadius(fxeDynLightsourceHandle DLSH, float NewRadius);


