
#define _FXDRIVER_

typedef struct
{
  // The string that identifies the driver
  // ex. "FxEngine Glide3 driver for voodoo2"
  //     "FxEngine OpenGl driver"

  char *DriverString;

  char *MoreInfo;

  int TextFileExist;

  // The version of FxEngine this driver is written for.
  // Use these variables to identify which version of FxEngine
  // the driver is written for.

  int MainVersion, UnderVersion;
                                  
} fxeDriverInfo, *fxeDriverInfoHandle;



// This routine returns a handle to a fxengine device driver.
// If failure the function returns NULL.
// This function is used to select a appropriate FxEngine driver.
// As fxengine will soon support different drivers
// (for different hardware, opengl etc) you must call this function
// before you call any other function in FxEngine.

extern fxeDriverInfoHandle fxeSelectDriver(void);
extern fxeDriverInfoHandle fxeSelectDriverLCC(HMODULE FxeDriver);


