
#include <glide.h>
#ifndef _FXTEXTURE_
#include "FxTexture.h"
#endif
#define _FXLIGHTMAP_


// define this constant if you want to use
// intensity maps instead of rgb maps
#define USE_INTENSITY_MAPS

// Lightmap lighting code for FxEngine

// Lightmap data size:

#ifndef USE_INTENSITY_MAPS

#define LIGHTMAP_SIZE 128
#define LIGHTMAP_WIDTH 8
#define NUM_LIGHTMAP_COORS 64


#define LIGHTMAP_FORMAT GR_TEXFMT_ARGB_1555
#define LIGHTMAP_ASPECT_RATIO GR_ASPECT_LOG2_1x1
#define LIGHTMAP_LOD GR_LOD_LOG2_8

#else

#define LIGHTMAP_SIZE 64
#define LIGHTMAP_WIDTH 8
#define NUM_LIGHTMAP_COORS 64


#define LIGHTMAP_FORMAT GR_TEXFMT_INTENSITY_8
#define LIGHTMAP_ASPECT_RATIO GR_ASPECT_LOG2_1x1
#define LIGHTMAP_LOD GR_LOD_LOG2_8

#endif

typedef struct
{
	float x,z;
} fxeLightmapCoors;

fxeLightmapCoors LocalLightmapCoors[NUM_LIGHTMAP_COORS];

#ifndef USE_INTENSITY_MAPS

typedef struct
{
	// Contains static data for lightmap initialized
	// during preprocessing.
	unsigned short StaticData[NUM_LIGHTMAP_COORS];
	// Contains data for this lightmap when taking into
	// consideration dynamic lightsources.
	unsigned short DownloadData[NUM_LIGHTMAP_COORS];
	// The tmu the lightmap data is downloaded to
	unsigned char TmuNumber;
	// The video memory address of the tmu.
	unsigned int TmuAddress;
	unsigned char StaticDataCopied;
	unsigned char AffectedByDynLight;
	float Heigths[NUM_LIGHTMAP_COORS];
	//float StoredLSLengths[NUM_LIGHTMAP_COORS];
	int SavedNumLightsources;
	fxeTextureHandle TexHandle;
} fxeLightmap;

#else

typedef struct
{
	unsigned char StaticData[NUM_LIGHTMAP_COORS];
	unsigned char DownloadData[NUM_LIGHTMAP_COORS];
	unsigned char TmuNumber;
	unsigned int TmuAddress;
	unsigned char StaticDataCopied;
	unsigned char AffectedByDynLight;
	float Heigths[NUM_LIGHTMAP_COORS];
	int SavedNumLightsources;
	fxeTextureHandle TexHandle;
} fxeLightmap;

#endif

GrTexInfo LightmapTexInfo;
FxU32 StartTMULightmapAddress;

void InitLightmapSystem(void);
int fxeLightmapInit(fxeLightmap *pLightmap);








