
// This file contains routine to set up a main window for
// your application. The window is initially maximized.
// The hinstance parameter specifies the handle of
// the instance of the windows application you want the
// main window to be created.

#include <windows.h>

HWND SetupMainWindow(HINSTANCE hInstance, void *WndProc)
{
	static char szAppName[] = "fxeWinTest";
  HWND        hwnd;
  WNDCLASS	 wndclass;

  wndclass.style         = CS_HREDRAW | CS_VREDRAW;
  wndclass.lpfnWndProc   = WndProc;
  wndclass.cbClsExtra    = 0;
  wndclass.cbWndExtra    = 0;
  wndclass.hInstance     = hInstance;
  wndclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION);
  wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW);
  wndclass.hbrBackground = (HBRUSH) GetStockObject (WHITE_BRUSH);
  wndclass.lpszMenuName  = NULL;
  wndclass.lpszClassName = szAppName;

  RegisterClass(&wndclass);

  hwnd = CreateWindow(szAppName,         /* window class name */
		"FxEngine Test Application", /* window caption */
    WS_MAXIMIZE | WS_TILEDWINDOW,     /* window style */
    0,           /* initial x position */
    0,           /* initial y position */
    0,           /* initial x size */
    0,           /* initial y size */
    NULL,                    /* parent window handle */
   	NULL,                    /* window menu handle */
   	hInstance,               /* program instance handle */
	  NULL);		               /* creation parameters */

	// Shows the mainwindow
  ShowWindow(hwnd, SW_SHOWMAXIMIZED);
	UpdateWindow(hwnd);
	return hwnd;

}
