
// 
              
// This demonstration program have been successfully compiled with
// Microsoft Visual C++ 5.0. It hope it should be easily converted to any
// C/C++ compiler out there. Sources is written in purely C so
// you don't need a C++ capable compiler.

// This sourcecode was written by Andreas Ingo 1998. Do you have any questions
// about this source then feel free to contact me at:
// andreas.ingo@swipnet.se
// or visit 3dfx Programming Secrets:
// http://welcome.to/3dfxPS


#include "Fx.h"
#include <math.h>
#include <windows.h>
#include <stdio.h>
#include <malloc.h>
#include "..\common files\wininit.h"
#include "..\common files\keyboard.h"
#include "..\common files\timesync.h"


// Some globals:
fxeObjectHandle OH;
fxeTextureHandle TH, TH2, TH3;
fxeColor ConstantColor;
int TimerID;
int Finished;
int Initialized;
char FrameCountString[80];
HINSTANCE AppInstance;
int Seconds;
int FxEngineStarted;
fxeColor FogColor;
unsigned long FPS ;
unsigned long NumPolys ;
char FPSString[80];
char astring[200];
fxeCharacterHandle CHandle;
fxeVector LightNormal;
char HaveFocus;


fxePerformance *PerformancePtr;

// Callback function for the main window of this program, this
// routine is called every time a message is sent from windows
// to this application.
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);


  
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    char * szCmdLine, int iCmdShow)
{
	static char szAppName[] = "fxeWinTest";
  HWND        hwnd;
  MSG         msg;



  float Distance;
  char Key;
  float x,y,z,ya,xa,za;
  int FxeMainVer;
  int FxeUnderVer;
  int LightsourceMode = 0;
  float r,g,b;
  int LandscapeIndex = 0;
  fxeColor TransColor;
  fxeColor FogColor;
  fxeObjectHandle Ship;
  int CurrShading = GOURAUD_SHADING;
  unsigned long CurrShape = FXE_SHAPE_POLYGONS;
  float EnvAlpha = 128;
  fxeLightsourceHandle LSH;
  fxeLandscapesParentHandle Landscape;
	fxeEmitterHandle EH;
	fxeColor InitColor, FinishColor;
	fxeTextureHandle PTH;
	fxeVector ForceVector;
	float ex,ez;
	int Loop;
	char *CollisionString;
	float ShipX = 400;
	fxeDynLightsourceHandle DLSH,DLSH2;
	float DynX,DynY,DynZ;
	fxeTextureHandle CHTex;
	fxeTextureHandle SmokeTex;
	fxeSmokeEmitterHandle SEH;
	fxeVector SmokeForce;
	fxeObjectHandle Sky;
	fxeObjectHandle OH;
	int IncVar;
	fxeTextureHandle BG, Black;

	// Lensflare variables:
	fxeLensflareHandle LFH;
	fxeTextureHandle FlareTextures[9];
	fxeTextureHandle FTH;
	float MulValues[9];
	float Radiuses[9];


  
	AppInstance = hInstance;
	Initialized = FXEFALSE;

	hwnd = SetupMainWindow(hInstance,WndProc); 

  TimerID = SetTimer(hwnd,1,1000,NULL);

  if (TimerID == 0)
  {
    return 1;
  }

  fxeGetVersion(&FxeMainVer,&FxeUnderVer);

  

  // Initialize FxEngine:

  if (fxeInitialize(hwnd,FXE_RES_640x480) == FXEFALSE)
  {
  	MessageBox(hwnd,"Couldn't initialize FxEngine!",
			NULL,MB_OK);
    return 1;
  }


	for (Loop=0;Loop<100;Loop++)
		fxeTextureLoad("lightmap.3df",FXE_TEXTURE_SPECIAL);

	for (Loop=0;Loop<10;Loop++)
		fxeTextureLoad("info.3df",FXE_TEXTURE_MAP);

	SmokeTex = fxeTextureLoad("smoke.3df",FXE_TEXTURE_MAP);
	CHTex = fxeTextureLoad("info.3df",FXE_TEXTURE_MAP);

	SmokeForce.x = 0.0f;
	SmokeForce.y = 0.0f;
	SmokeForce.z = 0.0f;

	SEH =	fxeSmokeEmitterCreate(-1500,400,0,1000,SmokeTex,
		10,&SmokeForce,1.005f,20,2.0f,350,2);
	fxeSmokeEmitterAddToWorld(SEH);

	OH = fxeObjectAdd(fxeObjectLoad("tank.3ds",OBJECT_3DS,100,FXETRUE));
	fxeObjectMove(OH,0,1500,0);
	fxeObjectSetShadingType(OH,GOURAUD_SHADING);
	//fxeObjectMakeEnviromentMapped(OH,fxeTextureLoad("hard.3df",FXE_TEXTURE_MAP),128);


	InitColor.r , InitColor.g, InitColor.b = 0;

	CHandle = fxeBitmapCreate(CHTex,FXETRUE,128,FXEFALSE,&InitColor);

	
	
	FTH = fxeTextureLoad("flare1.3df",FXE_TEXTURE_MAP);

	
	for (Loop=0; Loop<9; Loop++)
	FlareTextures[Loop] = FTH;
	MulValues[0] = 1.0f;
	MulValues[1] = 0.7f;
	MulValues[2] = 0.4f;
	MulValues[3] = 0.2f;
	MulValues[4] = 0.0f;
	MulValues[5] = -0.2f;
	MulValues[6] = -0.4f;
	MulValues[7] = -0.7f;
	MulValues[8] = -1.0f;
	Radiuses[0] = 90.0f;
	Radiuses[1] = 30.0f;
	Radiuses[2] = 60.0f;
	Radiuses[3] = 40.0f;
	Radiuses[4] = 25.0f;
	Radiuses[5] = 15.0f;
	Radiuses[6] = 20.0f;
	Radiuses[7] = 40.0f;
	Radiuses[8] = 50.0f;

	LFH = fxeLensflareCreate(9,FlareTextures,
		Radiuses,MulValues);

	fxeRenderWindowSet(300,0,200,240);

	InitColor.r = 1.0f;
	InitColor.g = 0.0f;
	InitColor.b = 0.0f;

	FinishColor.r = 1.0f;
	FinishColor.g = 1.0f;
	FinishColor.b = 0.0f;

	ForceVector.x = 0.0f;
	ForceVector.y = -0.2f;
	ForceVector.z = 0.0f;



	
	PTH = fxeTextureLoad("flare1.3df",FXE_TEXTURE_MAP);


	EH = fxeEmitterCreate(0,400,0,1000,&InitColor,&FinishColor,
		PTH,&ForceVector,1.05f,20.0f,2.0f);
	fxeEmitterAddToWorld(EH);

	fxeFarClippingPlaneSet(3000);


	Black = fxeTextureLoad("star.3df",FXE_TEXTURE_MAP);
	BG = fxeTextureLoad("Background.3df",FXE_TEXTURE_MAP);

	//fxeSkyboxAdd(50000,Black,Black,Black,Black,Black,Black);




  //fxeVSyncDisable();
  fxeFogSetMode(DISTANCE_FOGGING);
  FogColor.r = 0.0f;
  FogColor.g = 0.0f;
  FogColor.b = 1.0f;
  fxeFogSetColor(&FogColor);
  fxeBackgroundSetColor(&FogColor);

  TransColor.r = 0;
  TransColor.g = 0;
  TransColor.b = 0;


  // Load a character set:
  //CSH = fxeCharactersetLoad("char",FXEFALSE,FXEFALSE,128.0,FXETRUE,&TransColor,
  //  10,15.0,15.0);
  // Set loaded character set to default character set:
  //fxeSetDefaultCharacterset(CSH);


  // Load some textures from disk:

  //TH =  fxeTextureLoad("info.3df");

  //CH = fxeBitmapCreate(TH,FXETRUE,128,FXETRUE,&TransColor);
  TH2 = fxeTextureLoad("hard.3df",FXE_TEXTURE_MAP);
  TH3 = fxeTextureLoad("ground2.3df",FXE_TEXTURE_MAP);

  ConstantColor.r = 1;
  ConstantColor.g = 1;
  ConstantColor.b = 1;

	LightNormal.x = 0;
	LightNormal.y = 0.554700196f;
	LightNormal.z = 0.832050294f;

  LSH = fxeLightsourceAdd(0.5f,0.5f,0.5f,0,300000,1000000,0.0000f,LFH,&LightNormal);
	//LSH2 = fxeLightsourceAdd(0,0,1,10000,10000,0,0);



	Landscape = fxeLandscapeLoadFromFile("hills.3df",NULL,TH3,
		10000,10000,1000,&LightNormal,0.5f);
  fxeLandscapeAddToWorld(Landscape);


/*
	for (Loop=0; Loop<20;Loop++)
	{
		LightX = ((float)((rand()%10000)-5000));
		LightZ = ((float)((rand()%10000)-5000));
		LightY = fxeLandscapeGetHeightXZ(Landscape,LightX,LightY);
		fxeDynLightsourceAdd(700,LightX,LightY,LightZ,
			((float)(rand()%255))/255.0f,
			((float)(rand()%255))/255.0f,
			((float)(rand()%255))/255.0f);

	}
	*/

	DLSH = fxeDynLightsourceAdd(700,1000,0,0,1,0,0);
	fxeDynLightsourceActivate(DLSH);

	//DLSH2 = fxeDynLightsourceAdd(700,1000,1000,1500,1,0,0);
	//fxeDynLightsourceActivate(DLSH2);


/*
  Ship = fxeObjectLoad("tank.3ds",OBJECT_3DS,500,FXETRUE);
	
  if (Ship == NULL)                        
  {
    fxeShutdown();
    MessageBox(hwnd,"Couldn't load 3ds model",NULL,MB_OK);
    return 1;
  }

	//ActiveCamera->FollowPoint = FXETRUE;


  Ship = fxeObjectAdd(Ship);
	
  
  fxeObjectSetShape(Ship,FXE_SHAPE_POLYGONS);
  fxeObjectSetShadingType(Ship,GOURAUD_SHADING);
  //fxeObjectMakeEnviromentMapped(Ship,TH2,255);
  //fxeObjectMakeTranslucent(Ship,128);
*/


	// Setup some vars used in the main loop:
  Distance = 0.0;

  r = 0;
  g = 0;
  b = 0;
  x = 000.0;
  z = -800.0;
  y = fxeLandscapeGetHeightXZ(Landscape,x,z)+600.0f;
  ya = 0.0;
  xa = 0.0;
  za = 0.0;

	Key = 0;

	Finished = FXEFALSE;

	Initialized = FXETRUE;

  Seconds = 0;

	HaveFocus = TRUE;


  // The main loop begins here:
  while (1)
	{
		// Perform standard window message handling
		if	(PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE) == TRUE)
    {
			// A message was send to the application:
			if	(!GetMessage(&msg,NULL,0,0))
			{
				// Terminate message was sent
				return msg.wParam;
			}

			TranslateMessage(&msg);
      DispatchMessage(&msg);
    }
		else
		{
			if (HaveFocus == TRUE)
			{
      

			// No message was sent to the application
			// - update graphics

      if (Finished == FXEFALSE)
      {
        if (Distance < 359.0)
          Distance++;
        else
          Distance=1;

				//fxeObjectRotate(OH,1,1,1);

				ActiveCamera->PointToFollow.x = 800;
				ActiveCamera->PointToFollow.y = ShipX;
				ActiveCamera->PointToFollow.z = -400;

				DynX = (float)sin(DegToRad(Distance))*1000;
				DynZ = 300.0f;
				DynY = fxeLandscapeGetHeightXZ(Landscape,0,0);
				fxeDynLightsourceChangeXYZ(DLSH,DynX,DynY,DynZ);


				fxeObjectRotate(OH,1,1,1);
 
        fxeCameraMove(x,y,z);
				fxeCameraRotate(xa,ya,za);

				
				ex = 900.0f+(float)sin(DegToRad(Distance))*400.0f;
				ez = (float)cos(DegToRad(Distance))*400.0f;

				fxeEmitterChangeProperties(EH,DynX,DynY+150,DynZ,&ForceVector);
				fxeEmitterAddParticles(EH,2);


				if (CheckKey(VkKeyScan('o')))
					ShipX+=10;
				if (CheckKey(VkKeyScan('l')))
					ShipX-=10;

        
				if (CheckKey(VK_LEFT) && ya>0) ya--;
        else if (CheckKey(VK_LEFT) && ya==0) ya=359;

        if (CheckKey(VK_RIGHT) && ya<360) ya++;
        else if (CheckKey(VK_RIGHT) && ya==360) ya=1;

				if (CheckKey(VkKeyScan('1')))
					y=y+20;
				if (CheckKey(VkKeyScan('2')))
					y=y-20;
        if (CheckKey(VK_UP))
          z = z + (float)cos(DegToRad(ya)) * 20.0f;

        if (CheckKey(VK_UP))
          x = x + (float)sin(DegToRad(ya)) * 20.0f;

        if (CheckKey(VK_DOWN))
          z = z - (float)cos(DegToRad(ya)) * 20.0f;

        if (CheckKey(VK_DOWN))
          x = x - (float)sin(DegToRad(ya)) * 20.0f;

        if (CheckKey(VkKeyScan('G')))
        {
          fxeObjectSetShadingType(OH,GOURAUD_SHADING);
          CurrShading = GOURAUD_SHADING;
        }
        if (CheckKey(VkKeyScan('F')))
        {
          fxeObjectSetShadingType(OH,FLAT_SHADING);
          CurrShading = FLAT_SHADING;
        }

        if (CheckKey(VkKeyScan('A')))
        {
          fxeObjectSetShape(OH,FXE_SHAPE_POLYGONS);
          CurrShape = FXE_SHAPE_POLYGONS;
        }


        if (CheckKey(VkKeyScan('S')))
        {
          fxeObjectSetShape(OH,FXE_SHAPE_LINES);
          CurrShape = FXE_SHAPE_LINES;
        }

        if (CheckKey(VkKeyScan('D')))
        {
          fxeObjectSetShape(OH,FXE_SHAPE_POINTS);
          CurrShape = FXE_SHAPE_POINTS;
        }

        // Rotate the camera according to the ya variable
        //fxeCameraRotate(xa,ya,za);

        // Move the camera according to the x and z variables



				fxeRenderWindowSet(50,50,540,380);

				fxeBackgroundClear();

        fxeWorldRender(FXEFALSE);

        fxeSetRenderState(FXE_RENDER_2D);
/*
				if (fxeObjectDetectCollisionLandscape(Ship,Landscape) == FXETRUE)
				{
					CollisionString = "Collision Landscape-Object";
				}
				else
					CollisionString = "No Collision";

        sprintf(FPSString,"FPS: %d NumPolys/Sec: %d",(int)(FPS),(int)(NumPolys));

				//fxeStrDrawGrid(0,0,"FxEngine 0.40 by Andres Ingo 1998");
				//fxeStrDrawGrid(0,1,"If you want help with the engine contact");
				//fxeStrDrawGrid(0,2,"me by email at andreas.ingo@swipnet.se.");
*/
	
        fxeSetRenderState(FXE_RENDER_3D);

        fxeWorldDisplay();
				}

      }
    }
  }
}


LRESULT CALLBACK WndProc (HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
{

	switch (iMsg)
  {
  	case WM_CREATE:
    	return 0;

		case WM_ACTIVATE:
			if ((wParam & 0xffff) == WA_INACTIVE)
			{
				HaveFocus = FALSE;
				fxeLooseFocus();
			}
			else
			{
				HaveFocus = TRUE;
				fxeSetFocus();
			}
			return 0;


    case WM_TIMER:

      if (wParam == 1)
      {
        Seconds++;

        PerformancePtr = fxePerformanceGet();
        FPS = PerformancePtr->FrameCount;
        NumPolys = PerformancePtr->NumPolys;
        fxePerformanceInit();
        return 0;
      }
      else
        break;

		case WM_KEYDOWN:

			// Check if the escape key was pressed:
			if (wParam == VK_ESCAPE && Initialized == TRUE)
			{

  			fxeShutdown();

        KillTimer(hwnd,TimerID);


				Finished = FXETRUE;
				PostQuitMessage(0);
			}

			return 0;

    case WM_DESTROY:
    	PostQuitMessage(0);

      return 0;
  }

	// Perform default handling of unhandled messages sent to the
	// application:
	return DefWindowProc(hwnd, iMsg, wParam, lParam);
}


