
// Source file for FxEngines 3d animation capabilities

#ifndef _FXENGINE_
#include "fxenginedrv.h"
#endif

void fxeCameraSetActive(fxeCameraHandle CH)
{
  ActiveCamera = CH;
}  

fxeCameraHandle fxeCameraCreate(float wx, float wy, float wz,
  float ax, float ay, float az)
{
  fxeCameraHandle pCamera;

  pCamera = (fxeCameraHandle)malloc(sizeof(fxeCamera));
  if (pCamera == NULL)
    return NULL;

  pCamera->x = wx; pCamera->y = wy; pCamera->z = wz;
  pCamera->ax = ax; pCamera->ay = ay; pCamera->az = az;
  pCamera->NumFramesLeft = 0;
  pCamera->FollowPoint = FXEFALSE;

  return pCamera;
}

void fxeCameraMoveIncremental(int NumFrames,
  fxeVector *pMoveVector, float RotX, float RotY, float RotZ)
{
  ActiveCamera->NumFramesLeft = NumFrames;
  ActiveCamera->IncX = pMoveVector->x/(float)NumFrames;
  ActiveCamera->IncY = pMoveVector->y/(float)NumFrames;
  ActiveCamera->IncZ = pMoveVector->z/(float)NumFrames;
  ActiveCamera->RotX = RotX/(float)NumFrames;
  ActiveCamera->RotY = RotY/(float)NumFrames;
  ActiveCamera->RotZ = RotZ/(float)NumFrames;
}

void fxeCameraEnableSyncToPoint(float x, float y, float z)
{
  ActiveCamera->PointToFollow.x = x;
  ActiveCamera->PointToFollow.y = y;
  ActiveCamera->PointToFollow.z = z;
	ActiveCamera->FollowPoint = FXETRUE;
}

void fxeCameraDisableSyncToPoint(void)
{
  ActiveCamera->FollowPoint = FXEFALSE;
}

  
  
  
  
  
  
  
