
#include "FxCharacter.h"
#include "FxGlobals.h"
#include "FxTexture.h"

unsigned char StrOpacity;
fxeColor StrColor;
fxeTextureHandle StrTexture;
int GridWidth, GridHeigth;


void fxeStrDefaultProperties(void)
{
	StrOpacity = 255;
	StrColor.r = 255;
	StrColor.g = 255;
	StrColor.b = 255;
	StrTexture = DefaultStrTexture;
	GridWidth = 40;
	GridHeigth = 30;
}

void fxeStrSetColor(float r, float g, float b)
{
	StrColor.r = r;
	StrColor.g = g;
	StrColor.b = b;
}

void fxeStrSetOpacity(unsigned char Opacity)
{
	StrOpacity = Opacity;
}

void fxeStrSetTexture(fxeTextureHandle CharSetTex)
{
	StrTexture = CharSetTex;
}

void fxeStrSetGridDimensions(int Width, int Height)
{
	GridWidth = Width;
	GridHeigth = Height;
}

void fxeStrDrawGrid(int GridX, int GridY, char *String)
{
	int IncX, IncY;
	float u,v;
	int x, y;

	fxeDrawVertex CharVertices[4];

	IncX = (int)HorRes/GridWidth;
	IncY = (int)VerRes/GridHeigth;

	x = IncX*GridX;
	y = ((int)VerRes-1)-IncY*GridY;

	// Enable chromakeying
  grChromakeyMode(GR_CHROMAKEY_ENABLE);
  grChromakeyValue(0);

	// Disable Depth buffering
	grDepthBufferMode(GR_DEPTHBUFFER_DISABLE);

	grColorCombine(GR_COMBINE_FUNCTION_SCALE_OTHER,
		GR_COMBINE_FACTOR_LOCAL,GR_COMBINE_LOCAL_CONSTANT,
		GR_COMBINE_OTHER_TEXTURE,FXFALSE);

	grConstantColorValue((((unsigned int)StrOpacity)<<24)+
		(((unsigned int)StrColor.r)<<16)+
		(((unsigned int)StrColor.g)<<8)+
		((unsigned int)StrColor.b));

	// Setup tmu with characterset texture
	SetupTexture(StrTexture);
	
	if (String == NULL)
		return;

	CharVertices[0].q = 1.0f;
	CharVertices[1].q = 1.0f;
	CharVertices[2].q = 1.0f;
	CharVertices[3].q = 1.0f;

	CharVertices[0].u0 = 0.0f;
	CharVertices[0].v0 = 0.0f;

	CharVertices[1].u0 = 0.0f;
	CharVertices[1].v0 = 255.0f;

	CharVertices[2].u0 = 255.0f;
	CharVertices[2].v0 = 255.0f;

	CharVertices[3].u0 = 255.0f;
	CharVertices[3].v0 = 0.0f;


	while (*String != 0)
	{
		
		u = ((float)((*String)%16))*16.0f;
		v = ((float)((*String)/16))*16.0f;

		CharVertices[0].x = (float)(x);
		CharVertices[0].y = (float)(y);
		CharVertices[0].u0 = u;
		CharVertices[0].v0 = v;
		CharVertices[1].x = (float)(x);
		CharVertices[1].y = (float)(y-(IncY-1));
		CharVertices[1].u0 = u;
		CharVertices[1].v0 = v+15.0f;
		CharVertices[2].x = (float)(x+(IncX-1));
		CharVertices[2].y = (float)(y-(IncY-1));
		CharVertices[2].u0 = u+15.0f;
		CharVertices[2].v0 = v+15.0f;
		CharVertices[3].x = (float)(x+(IncX-1));
		CharVertices[3].y = (float)(y);
		CharVertices[3].u0 = u+15.0f;
		CharVertices[3].v0 = v;

		grDrawTriangle(&CharVertices[0],&CharVertices[1],
			&CharVertices[2]);
		grDrawTriangle(&CharVertices[2],&CharVertices[3],
			&CharVertices[0]);

		x += IncX;
		if (x >= (int)HorRes)
		{
			y	-= IncY;
			x = 0;
		}
		String++;
	}

	// Enable chromakeying
  grChromakeyMode(GR_CHROMAKEY_DISABLE);
  grChromakeyValue(0);

	// Disable Depth buffering
	grDepthBufferMode(GR_DEPTHBUFFER_WBUFFER);

	grColorCombine(GR_COMBINE_FUNCTION_SCALE_OTHER,
		GR_COMBINE_FACTOR_LOCAL,GR_COMBINE_LOCAL_ITERATED,
		GR_COMBINE_OTHER_TEXTURE,FXFALSE);

	grConstantColorValue(((unsigned int)255<<24));
}

void fxeStrDrawXY(int x, int y, char *String)
{
}

void fxeCharDrawGrid(int x, int y, char Character)
{
}

void fxeCharDrawXY(int x, int y, char Character)
{

}
