
// Resource loading functions:
// These functions can load resources from
// the executable file. In FxEngine this
// can for example be 3df texture files 
// and 3ds object files.

#include <windows.h>

// Loads a custom resource from the executable file
// and returns a pointer to it.


void *fxeLoadResource(int ResID, char *ResType, int *ResSize)
{
	HRSRC Resource;
	HGLOBAL ResourceHandle;
	LPVOID LockedMemory;

	// First see if we can find the resource:
	Resource = FindResource(NULL,MAKEINTRESOURCE(ResID),ResType);
	if (Resource == NULL)
	{
		return NULL;
	}

	*ResSize = SizeofResource(NULL,Resource);
	if (*ResSize == 0)
		return NULL;

	ResourceHandle = LoadResource(NULL,Resource);
	if (ResourceHandle == NULL)
		return NULL;

	LockedMemory = LockResource(ResourceHandle);
	if (LockedMemory == NULL)
		return NULL;
}



