
#ifndef _FXENGINE_
#include "fxenginedrv.h"
#endif


fxeObjectHandle GlobalSkyboxHandle = NULL;

int fxeSkyboxAdd(float Radius, fxeTextureHandle FrontTexture,
	fxeTextureHandle LeftTexture, fxeTextureHandle RearTexture,
	fxeTextureHandle RightTexture, fxeTextureHandle UpTexture,
	fxeTextureHandle DownTexture)
{
	fxeObjectHandle Sky;
	int Loop;

	Sky = fxeObjectInitDefaultState();

	fxeObjectAddVertex(Sky,-Radius,Radius,Radius);
	fxeObjectAddVertex(Sky,-Radius,-Radius,Radius);
	fxeObjectAddVertex(Sky,Radius,-Radius,Radius);
	fxeObjectAddVertex(Sky,Radius,Radius,Radius);
	fxeObjectAddVertex(Sky,-Radius,Radius,-Radius);
	fxeObjectAddVertex(Sky,-Radius,-Radius,-Radius);
	fxeObjectAddVertex(Sky,Radius,-Radius,-Radius);
	fxeObjectAddVertex(Sky,Radius,Radius,-Radius);
	
	// Front Side
	fxeObjectAddPolygon(Sky,2,1,0,FXEFALSE,FrontTexture,1,1,0,1,0,0);
	fxeObjectAddPolygon(Sky,0,3,2,FXEFALSE,FrontTexture,0,0,1,0,1,1);

	// Left Side
	fxeObjectAddPolygon(Sky,1,5,4,FXEFALSE,LeftTexture,1,1,0,1,0,0);
	fxeObjectAddPolygon(Sky,4,0,1,FXEFALSE,LeftTexture,0,0,1,0,1,1);

	// Rear Side
	fxeObjectAddPolygon(Sky,5,6,7,FXEFALSE,LeftTexture,1,1,0,1,0,0);
	fxeObjectAddPolygon(Sky,7,4,5,FXEFALSE,LeftTexture,0,0,1,0,1,1);

	// Right Side
	fxeObjectAddPolygon(Sky,6,2,3,FXEFALSE,RightTexture,1,1,0,1,0,0);
	fxeObjectAddPolygon(Sky,3,7,6,FXEFALSE,RightTexture,0,0,1,0,1,1);

	// Up Side
	fxeObjectAddPolygon(Sky,3,0,4,FXEFALSE,UpTexture,1,1,0,1,0,0);
	fxeObjectAddPolygon(Sky,4,7,3,FXEFALSE,UpTexture,0,0,1,0,1,1);

	// Down Side
	fxeObjectAddPolygon(Sky,6,5,1,FXEFALSE,DownTexture,1,1,0,1,0,0);
	fxeObjectAddPolygon(Sky,1,2,6,FXEFALSE,DownTexture,0,0,1,0,1,1);

	for (Loop=0;Loop<12;Loop++)
	{
		Sky->PolygonList[Loop].AmbientColor.r = 1.0f;
		Sky->PolygonList[Loop].AmbientColor.g = 1.0f;
		Sky->PolygonList[Loop].AmbientColor.b = 1.0f;
	}

	fxeObjectPerformPrecalculations(Sky,Radius);
	fxeObjectSetShadingType(Sky,GOURAUD_SHADING);
	GlobalSkyboxHandle = Sky;
	TransformToWorld(GlobalSkyboxHandle);

	return FXETRUE;
}



void fxeSkyboxDisable(void)
{
	GlobalSkyboxHandle = NULL;
}

