#include <iostream.h>
#include <conio.h>
#include <math.h>

//pitch is up and down,  yaw is turning side to side

#define DegToRad(d)	((double)d * 0.017453292)
#define RadToDeg(r)	((double)r * 57.2957795)

typedef struct D_Vector
{
	float x,y,z,w;

} D_Vector;

float CosLookup[36100];
float SinLookup[36100];
float ASinLookup[201];
float ACosLookup[201];
float SqrLookup[100000];

void RotationToDirection(float pitch,float yaw, D_Vector *direction)
{
	int p = ((int)pitch*100);    
	int y = ((int)yaw*100);
	direction->x = (float)(SinLookup[y] * CosLookup[p]);
	direction->y = (float)SinLookup[p];
	direction->z = (float)(CosLookup[p] * CosLookup[y]);
}

void InitialAngle(float *pitch, float *yaw, D_Vector direction)
{
	//get xy into one "quadrant"
	float dx, dy;
	if(direction.y < 0)
		dy = -direction.y;
	else
		dy = direction.y;  

	if(direction.x < 0)
		dx = -direction.x;
	else
		dx = direction.x;

	//get the pitch and yaw for THAT quadrant.
//	*pitch = (float) RadToDeg(asin(dy));
//	*yaw =   (float) RadToDeg(asin(dx));
	*pitch = (float) RadToDeg(ASinLookup[int(dy*100+100)]);  //same thing using fancy lookup tables
	*yaw =   (float) RadToDeg(ASinLookup[int(dx*100+100)]);

	//expand the y range to half of the circle.
	if(direction.y < 0.0f)
	{
		*pitch= 360.0f - *pitch;
	}
	//expand the x range to half of the circle
	if(direction.x < 0.0f)
	{
		*yaw = 360.0f - *yaw;
	}
	//untill now,  the circle has existed basically in half of the circle, in x and y.
	//to add the 3rd dimention to pitch and roll,  we simply check to see if 
	//the vector points to the other half of the circle ( -z ). And if so,  rotate the
	//yaw accrodingly.
	if(direction.z < 0.0f) 
	{
		*yaw = 90 + (90.0f - *yaw);
	}


}

void D_DegRange(float *a)
{
	while(*a >= 360.0f || *a < 0.0f)
	{
		if(*a >= 360.0) *a -= 360.0;
		else if(*a < 0.0) *a += 360.0;
	}
}

void main()
{
float pitch = 45.0f, yaw = 45.0f;
D_Vector d;

	d.x = -.7071067f;
	d.y = -.7071067f;
	d.z = 0;//.7071067f;

  for (int Loop=0; Loop<36100; Loop++)
  {
    CosLookup[Loop] = (float)cos(DegToRad((float)Loop/100.0f));
    SinLookup[Loop] = (float)sin(DegToRad((float)Loop/100.0f));
  }

  for(float loop=-1.0f; loop <= 1.0f ;loop+= 0.01f)
  {
	ASinLookup[int(loop*100 + 100)] = (float)asin(loop);
	ACosLookup[int(loop*100 + 100)] = (float)acos(loop);
  }

  for(Loop=0; Loop< 100000; Loop++)  //does square roots of 2 decimal placed numbers from 0 to 1000 (0-31.62)
  {
	SqrLookup[Loop] = (float)sqrt(Loop/100.0f);
  }


 	InitialAngle(&pitch, &yaw, d);
	cout<<"Direction: "<<d.x<<"  "<<d.y<<"  "<<d.z<<endl;
	cout<<"Pitch: "<<pitch<<",  Yaw: "<<yaw<<endl;
	



}