
#include "lightmap.h"
#ifndef _FXENGINE_
#include "fxenginedrv.h"
#endif
#include "fxglobals.h"
#include <glide.h>
#include "FxMalloc.h"
#include "FxTexture.h"

// Returns FXETRUE if successful and FXEFALSE otherwise.
int fxeLightmapInit(fxeLightmap *pLightmap)
{
	fxeTexture *pTexture;
	pTexture = (fxeTexture*)FxMalloc(sizeof(fxeTexture));

	pLightmap->TexHandle = pTexture;

	pTexture->TexInfo.format = LIGHTMAP_FORMAT;
	pTexture->TexInfo.aspectRatioLog2 = LIGHTMAP_ASPECT_RATIO;
	pTexture->TexInfo.smallLodLog2 = LIGHTMAP_LOD;
	pTexture->TexInfo.largeLodLog2 = LIGHTMAP_LOD;
	pTexture->TexInfo.data = pLightmap->DownloadData;

	pTexture->Used = FXETRUE;
	pTexture->NumBytes = LIGHTMAP_SIZE;
	pTexture->NumBytesInTmu = LIGHTMAP_SIZE;
	pTexture->TexType = FXE_TEXTURE_SPECIAL;
	pTexture->TextureData = pLightmap->DownloadData;
	pTexture->Changed = FXEFALSE;
	pTexture->Filename = NULL;

	pLightmap->StaticDataCopied = FXEFALSE;
	pLightmap->SavedNumLightsources = 0;

	// Add the new texture to the texture cache:
	pTexture->Next = pFirstTexture;
	pFirstTexture = pTexture;

	if (NumTexelFx == 1)
	{
		pLightmap->TmuAddress = fxeTMUAllocateMemory(GR_TMU0,LIGHTMAP_SIZE);
		if (pLightmap->TmuAddress == 0xffffffff)
			pTexture->DownloadedToTRAM = FXEFALSE;
		else
			pTexture->DownloadedToTRAM = FXETRUE;
		pTexture->VideomemoryAddress = pLightmap->TmuAddress;

		pLightmap->TmuNumber = 0;
		return FXETRUE;
	}
	else
	{
		pLightmap->TmuAddress = fxeTMUAllocateMemory(GR_TMU1,LIGHTMAP_SIZE);
		if (pLightmap->TmuAddress == 0xffffffff)
			pTexture->DownloadedToTRAM = FXEFALSE;
		else
			pTexture->DownloadedToTRAM = FXETRUE;
		pTexture->VideomemoryAddress = pLightmap->TmuAddress;
		pLightmap->TmuNumber = 1;
		return FXETRUE;
	}
}


void InitLightmapSystem(void)
{
	LightmapTexInfo.format = LIGHTMAP_FORMAT;
	LightmapTexInfo.aspectRatioLog2 = LIGHTMAP_ASPECT_RATIO;
  LightmapTexInfo.smallLodLog2 = LIGHTMAP_LOD;
  LightmapTexInfo.largeLodLog2 = LIGHTMAP_LOD;
}
